<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.4 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.4: Modeling for synthesis</h1>
                    <p>
                        Now that you know about requirement automata and invariants, it is time to see how they can be modeled in CIF.
                        Besides that, we will discuss some other aspects related to modeling for synthesis using CIF.
                        That is, we will discuss limitations for data types of variables when using synthesis, and how that affects modeling and the synthesis algorithm.
                        And, we will discuss the concept of monitors, which can be useful when modeling requirements, as well as how to model monitors in CIF.
                    </p>

                    <h2>Modeling requirements in CIF</h2>
                    <p>
                        In the third module, you learned that plant and supervisor automata are regular automata that are indicated as either being part of the plant or the supervisor, using the <code>plant</code> and <code>supervisor</code> keywords, respectively.
                        Such a keyword can be placed before the <code>automaton</code> keyword, or can be used instead of it.
                        Automata can also be indicated as being a requirement, by similarly using the <code>requirement</code> keyword.
                    </p>
                    <p>
                        Earlier in this module, you learned about requirement invariants.
                        Requirement invariants are indicated either by the <code>requirement</code> keyword, or by the <code>requirement invariant</code> keywords, whichever you prefer.
                    </p>
                    <p>
                        The <a href="requirement-automata-and-invariants.html#requirement-automata">requirement automaton</a> from the <a href="requirement-automata-and-invariants.html#example">bridge deck and traffic light example</a> from earlier in this module can be modeled in CIF as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            requirement ClosedWhenGreen:
                                location ClosedGreen:
                                    initial;
                                    marked;
                                    edge to_red           goto ClosedRed;

                                location ClosedRed:
                                    edge to_green         goto ClosedGreen;
                                    edge partially_opened goto PartiallyOpenRed;

                                location PartiallyOpenRed:
                                    edge opened           goto OpenRed;
                                    edge closed           goto ClosedRed;

                                location OpenRed:
                                    edge partially_opened goto PartiallyOpenRed;
                            end
                        </code>
                    </pre>
                    <p>
                        The 10 different <a href="requirement-automata-and-invariants.html#requirement-invariants">requirement invariants</a> from that same example, two state requirements and eight state/event exclusion requirements, can be modeled in CIF as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            requirement not ((BridgeDeck.PartiallyOpen or BridgeDeck.Open) and TrafficLight.Green);
                            requirement (BridgeDeck.Closed and TrafficLight.Green) or TrafficLight.Red;

                            requirement BridgeDeck.Closed and TrafficLight.Green disables partially_opened;
                            requirement BridgeDeck.PartiallyOpen or BridgeDeck.Open disables to_green;
                            requirement TrafficLight.Green disables partially_opened;
                            requirement BridgeDeck.PartiallyOpen or BridgeDeck.Open disables to_green;
                            requirement not TrafficLight.Red disables partially_opened;
                            requirement not BridgeDeck.Closed disables to_green;
                            requirement partially_opened needs TrafficLight.Red;
                            requirement to_green needs BridgeDeck.Closed;
                        </code>
                    </pre>
                    <p>
                        Sometimes, you may write the same state/event exclusion requirement for multiple events.
                        For instance, if the emergency mode of a system is activated by an operator pressing the emergency button, none of the system's motors may be started.
                        In CIF, you can combine these requirements into a single requirement, by simply listing multiple events for the state/event exclusion requirement.
                        For instance, the following example gives three separate state/event exclusion requirements, and their combination into a single requirement:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            requirement EmergencyMode.On disables Motor1.c_start;
                            requirement EmergencyMode.On disables Motor2.c_start;
                            requirement EmergencyMode.On disables Motor3.c_start;

                            requirement EmergencyMode.On disables {Motor1.c_start, Motor2.c_start, Motor3.c_start};
                        </code>
                    </pre>
                    <p>
                        Similarly, multiple events can be given for <code><strong>needs</strong></code> state/event exclusion requirements.
                    </p>
                    <p>
                        For traceability and readability, requirement invariants can be given a name.
                        This applies to both state requirement invariants and state/event exclusion requirement invariants.
                        Here is an example of the latter:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            requirement RQ1: EmergencyMode.On disables Motor1.c_start;
                            requirement RQ2: EmergencyMode.On disables Motor2.c_start;
                            requirement RQ3: EmergencyMode.On disables Motor3.c_start;
                        </code>
                    </pre>
                    <p>
                        State/event exclusion requirements with multiple events are a shorter form for writing multiple requirements, and since requirement names must be unique, state/event exclusion requirements with multiple events can not be given a name.
                    </p>

                    <h2>Synthesis requires finite data types</h2>
                    <p>
                        You learned previously that automata may declare discrete variables that hold a value of a certain type.
                        These variables can then be used in among others guards of edges and conditions of requirement invariants, and be updated on edges.
                        There are different data types, that indicate the possible values that a variable can have.
                        For instance, a boolean variable (keyword <code>bool</code>) can have values <code>true</code> and <code>false</code>.
                        And an integer variable (keyword <code>int</code>) can have whole numbers as its values, such as <code>1</code> or <code>32</code>.
                    </p>
                    <p>
                        To allow for synthesis, the data type must be finite, so that variables can only have a finite number of possible values.
                        For booleans, this is already the case, as with <code>true</code> and <code>false</code> it only allows two different values.
                        But, for integers, you must explicitly limit the allowed values, using <em>ranged</em> integer types.
                        For instance, if a variable can only have the values <code>1</code> through <code>5</code>, <code>1</code> and <code>5</code> included, you'd use the type <code>int[1..5]</code> instead of <code>int</code>.
                    </p>
                    <p>
                        If you the same bounds for integer types multiple times, you can define a constant for that bound, and use it multiple times, like this:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            const int MAX = 3;
                            disc int[0..MAX] count1;
                            disc int[0..MAX] count2;
                        </code>
                    </pre>
                    <p>
                        Although, if the variables are declared in the same automaton, and have the exact same type, you could also combine their declarations:
                    <p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            const int MAX = 3;
                            disc int[0..MAX] count1, count2;
                        </code>
                    </pre>
                    <p>
                        And, if you use the same type multiple times, you can also give it a name, and reuse it many times:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            const int MAX = 3;
                            type t = int[0..MAX];
                            disc t count1;
                            disc t count2;
                        </code>
                    </pre>
                    <p>
                        Here a type definition named <code>t</code> is defined as being equal to the type <code>int[0..MAX]</code>.
                        Type definition <code>t</code> can then be used in place of a type.
                    </p>

                    <h2>Staying within integer bounds</h2>
                    <p>
                        When a variable has a ranged integer type, it can only have the values that are part of the range.
                        That is, assigning it a value outside that range is invalid.
                        For instance, for a variable <code>x</code> with type <code>int[0..3]</code>, the assignment <code>x := 4</code> is invalid, as <code>4</code> is larger than the integer type's upper bound of <code>3</code>.
                        Assignments like this are invalid in CIF.
                    </p>
                    <p>
                        In some situations, the assignment itself is valid, but may in certain situations lead to the variable getting a value outside its range.
                        For instance, if for the same variable <code>x</code>, we have an assignment <code>x := x + 1</code>, then <code>x</code> can safely be incremented from <code>0</code> to <code>1</code>, <code>1</code> to <code>2</code>, and <code>2</code> to <code>3</code>.
                        But, if <code>x</code> has the value <code>3</code>, incrementing it by one will lead to it getting value <code>4</code>, which is outside its valid range.
                        Such a model is not flagged as being an invalid model when you edit it.
                        But, if you simulate the model, and <code>x</code> gets value <code>4</code>, this will lead to a <em>runtime error</em>.
                        The model is thus still an invalid model.
                    </p>
                    <p>
                        One way to make it a valid model, is to add a guard to the edge.
                        By adding guard <code>x &lt; 3</code>, <code>x</code> can only be incremented by one if <code>x</code> is less than <code>3</code>.
                        It can thus never get to value <code>4</code> any more, and thus the variable stays within its range.
                    </p>
                    <p>
                        While you should always ensure that your integer variables can't go out of range, you can also use synthesis for this.
                        That is, synthesis will also ensure, besides safety, non-blockingness, controllability and maximally permissiveness, that all variables remain with their ranges.
                        So, if you forget to add the <code>x &lt; 3</code> guard, synthesis will compute it for you, and still ensure that variables can't go out of range.
                    </p>
                    <p>
                        In the synthesis algorithm, preventing runtime errors is another preparation step.
                        That is, for every edge, a extra condition is computed for every integer variable that is assigned on the edge, and the guard of the edge is strengthened with that condition.
                        Furthermore, for a variable <code>x</code> with type <code>int[a..b]</code>, state requirement invariant <code>a &lt;= x and x &lt;= b</code> is added.
                        You'd think that either of these is sufficient, and theoretically that's correct.
                        But, due to some rather technical reasons related to how predicates are represented and manipulated during synthesis, which are beyond the scope of this course, the synthesis algorithm does both.
                    </p>

                    <h2>The updated synthesis algorithm</h2>
                    <p>
                        The synthesis algorithm still takes the uncontrolled plant and requirements as input, but now performs the following steps:
                    </p>
                    <ol>
                        <li>
                            For each edge of each automaton, compute the extra condition for every integer variable that is assigned on the edge, and the add it to the guard of the edge.
                        </li>
                        <li>
                            For each integer-typed variable <code>x</code> with type <code>int[a..b]</code>, add a state requirement invariant <code>a &lt;= x and x &lt;= b</code>.
                        </li>
                        <li>
                            Plantify the requirement automata to plant automata and state/event exclusion requirement invariants.
                        </li>
                        <li>
                            Determine all states where state requirement invariants don't hold.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Disable all transitions for controllable events in states where they violate a state/event exclusion requirement invariant.
                        </li>
                        <li>
                            Disable all transitions for uncontrollable events in states where they violate a state/event exclusion requirement invariant.
                            Additionally, mark their source states as bad states and remove them.
                        </li>
                    </ol>
                    <ol start="7">
                        <li>
                            Determine all blocking states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Determine all non-controllable states, the states from which an uncontrollable-event transition is possible to a bad state.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Optionally, determine all unreachable states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Disable all transitions for controllable events in states where they lead to a bad state.
                        </li>
                        <li>
                            If any of the previous steps led to removing any states or disabling any transitions, repeat the steps again, starting from step 7.
                        </li>
                    </ol>
                    <p>
                        The first four steps are preparation steps that are only performed once.
                        The remaining steps are repeated as often as is necessary, until no more behavior is removed.
                    </p>

                    <h2>Enumerations</h2>
                    <p>
                        For synthesis, CIF supports only a few data types.
                        Besides booleans and ranged integers, it also supports enumerations.
                    </p>
                    <p>
                        Enumerations represent collections of related entities, such as types of products, types of available resources, available machine types, different countries, different colors, different genders, and so on.
                        It is possible to use numbers to represent the different entities, for instance <code>0</code> for red, <code>1</code> for orange, and <code>2</code> for green, to represent the different colors of a traffic light.
                        However, these numbers are rather arbitrary.
                        Furthermore, they don’t actually represent numbers, but rather they represent one of the entities (red, orange, green).
                        Enumerations allow giving each entity a name, and to use those names instead of numbers.
                        This usually makes the model easier to read and understand.
                        For instance, consider the following:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            enum TrafficColor = RED, ORANGE, GREEN;
                        </code>
                    </pre>
                    <p>
                        The <code>enum</code> keyword is used to declare an enumeration.
                        The <code>TrafficColor</code> enumeration has three possible values or <em>literals</em>.
                        The literals are named <code>RED</code>, <code>ORANGE</code>, and <code>GREEN</code>.
                        An enumeration can be used as data type, and the enumeration literals can be used as values:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            disc TrafficColor light = RED;
                        </code>
                    </pre>
                    <p>
                        The <code>TrafficColor</code> enumeration is used as the type of the <code>light</code> variable.
                        The <code>light</code> variable is given value <code>RED</code> as its initial value.
                        The default value of an enumeration type is its first literal (<code>RED</code> in this case).
                        However, it is usually preferred to explicitly initialize variables with enumeration types, for readability.
                    </p>
                    <p>
                        Variables with an enumeration type can be compared and assigned, similar to boolean and integer variables:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            edge change_color when light = RED do light := GREEN;
                        </code>
                    </pre>
                    <p>
                        This edge has a guard that compares the value of the <code>light</code> variable to enumeration literal <code>RED</code>.
                        Only if the <code>light</code> is currently <code>RED</code>, may this edge be taken.
                        The edge further assigns enumeration literal <code>GREEN</code> as the new value of variable <code>light</code>.
                    </p>

                    <h2>Monitors</h2>
                    <p>
                        You previously learned that requirement automata are taken into account during synthesis by plantifying them to non-restrictive plant automata, and state/event exclusion requirement invariants.
                        Such a plantified requirement automaton essentially monitors the state of the plant, but does not restrict it.
                        The restrictions are moved to state/event exclusion requirement invariants, that can then be expressed over the locations of the plantified automaton.
                        Such a plantified automaton can be expressed in CIF as a <em>monitor automaton</em>, also simply called a <em>monitor</em>.
                        For instance, the <a href="synthesis-with-requirements.html#railway-requirement-plantified">plantified version</a> of the requirement automaton from the railway crossing example from earlier in this module, can be modeled in CIF as a monitor automaton as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            requirement RailwayCrossingOrder2:
                                monitor open, close, turn_on, turn_off;

                                location OffOpen:
                                    initial;
                                    marked;
                                    edge turn_on  goto OnOpen;

                                location OnOpen:
                                    edge close    goto OnClosed;

                                location OnClosed:
                                    edge turn_off goto OffClosed;

                                location OffClosed:
                                    edge open     goto OffOpen;
                            end
                        </code>
                    </pre>
                    <p>
                        This automaton monitors four of the events in its alphabet: <code>open</code>, <code>close</code>, <code>turn_on</code> and <code>turn_off</code>.
                        This essentially means self-loop edges are automatically added to ensure that this automaton does not disable these events in any state.
                        Since in this case the automaton monitors all of the events in its alphabet, we may also shorten the monitor declaration to simply <code>monitor;</code>.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements are true about modeling for synthesis with CIF?",
                                answers: [
                                    "All requirements, being automata or invariants, are modeled using the <code>requirement</code> keyword.",
                                    "All requirements, being automata or invariants, can be given a name.",
                                    "State/event exclusion requirements, regardless of using disables or needs, can restrict multiple events.",
                                    "You may only use variables with a boolean, ranged integer or enumeration data type.",
                                    "While synthesis ensures that integer variables stay within their range, it is better to ensure this already in your model using explicit guards.",
                                    "Enumerations with named literals can be used instead of a collection of integer numbers.",
                                    "Monitors are a convenient way to model that certain events should not be restricted by an automaton.",
                                    "Monitors can only be used for plantified requirements, and not for any other purpose.",
                                ],
                                correctAnswer: '1, 2, 3, 4, 5, 6, 7'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="synthesis-with-requirements.html">Go back to Module 4.3</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="performing-synthesis-with-cif.html">Proceed to Module 4.5</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
